package registrovehicular;
import static javax.swing.JOptionPane.showMessageDialog;

//Clase que implemente las operaciones basicas en una Organizacin SEcuencial 
import java.io.*; //Conjunto de clases para manejo de archivos

import javax.swing.JDesktopPane;
import javax.swing.JOptionPane;
public class OperacionesArchivos {
     public Vehiculo automovilx=null;
	    //Operacion de Lectura
		public String leerArchivo(String nomarch) {
			FileReader archivo=null;
			BufferedReader leer=null;
			//Se usa para almacenar temporalmente las lineas de texto extraidas del archivo
			String salida=""; 
			try {
				archivo=new FileReader(nomarch);
				leer=new BufferedReader(archivo); //Optimizar accesos a Disco
				String linea;
				do {
					linea=leer.readLine(); //Lee una linea de texto del archivo
					if (linea!=null) salida+=linea+"\n";
				} while (linea!=null);
				
			} catch (IOException ex) {
				showMessageDialog(null,"Error al abrir archivo");
			} finally {
				try {
					leer.close();
				} catch (Exception e) {
					showMessageDialog(null,"Error al cerrar archivo");
				}
			}
			return salida;
		}
		//Operacin de escritura de archivos de texto
		public void escribiArchivo(String nomarch,String entrada,boolean agregar) {
			FileWriter archivo=null;
			BufferedWriter escribir=null;
			try {
				//Parametro agregar sirve para indicar si se agrega el nuevo texto
				//al final del archivo o si se sobreescribe
				archivo=new FileWriter(nomarch,agregar);
				escribir=new BufferedWriter(archivo);
				if (agregar) escribir.append(entrada);
				else escribir.write(entrada);
				showMessageDialog(null,"Ya se guardo el archivo");
			} catch (IOException ex) {
				showMessageDialog(null,"Error al escribir archivo");
			}  finally {
				try {
					escribir.close();
				} catch (Exception e) {
					showMessageDialog(null,"Error al cerrar archivo");
				}
			}
		}	
		//Consultar registro
		public Vehiculo consultarArchivo(String nomarch,String placax) {
					FileReader archivo=null;
					BufferedReader leer=null;
					Vehiculo autox=null,autobuscar; 
					autobuscar=new Vehiculo(placax);
					try {
						archivo=new FileReader(nomarch);
						leer=new BufferedReader(archivo); 
						String linea;
						do {
							linea=leer.readLine(); 
							if (linea!=null) {
								autox=new Vehiculo(linea.split(","));
								if (autox.equals(autobuscar)) return autox;
								else autox=null;
							}
						} while (linea!=null);
						
					} catch (IOException ex) {
						showMessageDialog(null,"Error al abrir archivo");
					} finally {
						try {
							leer.close();
						} catch (Exception e) {
							showMessageDialog(null,"Error al cerrar archivo");
						}
					}
					return autox;
				}
		//Eliminar registro
		public void eliminarRegistro(String nomarch,String placax) {
			FileReader archivo=null;FileWriter temporal=null;
			BufferedReader leer=null;BufferedWriter escribir=null;
			Vehiculo autox=null,autobuscar; 
			autobuscar=new Vehiculo(placax);
			boolean encontro=false;
			try {
				archivo=new FileReader(nomarch);temporal=new FileWriter("vehiculos.tmp");
				leer=new BufferedReader(archivo); escribir=new BufferedWriter(temporal);
				String linea;
				do {
					linea=leer.readLine(); 
					if (linea!=null) {
						autox=new Vehiculo(linea.split(","));
						if (!autox.equals(autobuscar)) escribir.write(autox.toString());
						else encontro=true;
					}
				} while (linea!=null);

			} catch (IOException ex) {
				showMessageDialog(null,"Error al abrir archivo");
			} finally {
				try {
					leer.close();
					escribir.close();
					File maestro=new File("vehiculos.csv");
					File tempo=new File("vehiculos.tmp");
					maestro.delete();
					tempo.renameTo(maestro);
					if (!encontro) JOptionPane.showMessageDialog(null,"Registro no encontrado");
					else JOptionPane.showMessageDialog(null,"Operacion Exitosa");
				} catch (Exception e) {
					showMessageDialog(null,"Error al cerrar archivo");
				}
			}
		}
		//Modificar registro
		public void modificarRegistro(String nomarch,String placax,RegistroVehicular rv,OperacionesArchivos opera) {
			FileReader archivo=null;FileWriter temporal=null;
			BufferedReader leer=null;BufferedWriter escribir=null;
			Vehiculo autox=null,autobuscar; 
			autobuscar=new Vehiculo(placax);
			automovilx=null;
			boolean encontro=false;
			try {
				archivo=new FileReader(nomarch);temporal=new FileWriter("vehiculos.tmp");
				leer=new BufferedReader(archivo); escribir=new BufferedWriter(temporal);
				String linea;
				do {
					linea=leer.readLine(); 
					if (linea!=null) {
						autox=new Vehiculo(linea.split(","));
						if (!autox.equals(autobuscar)) escribir.write(autox.toString());
						//Aqui se realiza toda la operacion de modificacin
						else {automovilx=new Vehiculo(linea.split(","));encontro=true;
						 //Se manda llamar a la ventana de modificar datos
						ModificaVehiculo ventanaInterna=
						new ModificaVehiculo(rv,"Modificar Vehiculo",true,automovilx,opera);
						escribir.write(automovilx.toString());
						}
					}
				} while (linea!=null);

			} catch (IOException ex) {
				showMessageDialog(null,"Error al abrir archivo");
			} finally {
				try {
					leer.close();
					escribir.close();
					File maestro=new File("vehiculos.csv");
					File tempo=new File("vehiculos.tmp");
					maestro.delete();
					tempo.renameTo(maestro);
					if (!encontro) JOptionPane.showMessageDialog(null,"Registro no encontrado");
					else JOptionPane.showMessageDialog(null,"Operacion Exitosa");
				} catch (Exception e) {
					showMessageDialog(null,"Error al cerrar archivo");
				}
			}
		}
}
