package registrovehicular;
//Representa los objetos o registros con los que se trabajara en el archivo secuencial
public class Vehiculo {
	//Atributos o campos
	private String noPlaca; //Campo llave o clave para buscar
	private String marca;
	private int modelo;
	private String dueyo;
	private String color;
	//Constructores
	public Vehiculo(String noPlaca) {
		this.noPlaca=noPlaca;
	}
	public Vehiculo(String noPlaca, String marca, int modelo, String dueyo, String color) {
		super();
		this.noPlaca = noPlaca;
		this.marca = marca;
		this.modelo = modelo;
		this.dueyo = dueyo;
		this.color = color;
	}
	public Vehiculo(String [] linea) {
		super();
		this.noPlaca = linea[0];
		this.marca = linea[1];
		this.modelo = Integer.parseInt(linea[2]);
		this.dueyo = linea[3];
		this.color = linea[4];
	}
	//Metodos gets y sets
	public String getNoPlaca() {
		return noPlaca;
	}
	public void setNoPlaca(String noPlaca) {
		this.noPlaca = noPlaca;
	}
	public String getMarca() {
		return marca;
	}
	public void setMarca(String marca) {
		this.marca = marca;
	}
	public int getModelo() {
		return modelo;
	}
	public void setModelo(int modelo) {
		this.modelo = modelo;
	}
	public String getDueyo() {
		return dueyo;
	}
	public void setDueyo(String dueyo) {
		this.dueyo = dueyo;
	}
	public String getColor() {
		return color;
	}
	public void setColor(String color) {
		this.color = color;
	}
	public String mostrarDatos() {
		String salida="";
		salida+="Numero Placa:"+noPlaca+"\n";
		salida+="Marca:"+marca+"\n";
		salida+="Modelo:"+modelo+"\n";
		salida+="Dueo:"+dueyo+"\n";
		salida+="Color:"+color+"\n";
		return salida;
	}
	@Override
	public String toString() {
		return noPlaca + "," + marca + "," + modelo + "," + dueyo + "," + color +"\n" ;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Vehiculo other = (Vehiculo) obj;
		if (noPlaca == null) {
			if (other.noPlaca != null)
				return false;
		} else if (!noPlaca.equals(other.noPlaca))
			return false;
		return true;
	}
}
